SystemOrganization addCategory: #'Tp-TADP'!
SystemOrganization addCategory: #'Tp-TADP-Test'!

Trait named: #ConPosicion
	uses: {}
	category: 'Tp-TADP'!

Trait named: #Poceado
	uses: {}
	category: 'Tp-TADP'!

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 04:09'!
PorcentajeParaAgenciaGanadora
	self requirement! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:41'!
calculaGanadoresYRepartiPremios: jugadaGanadora
	| primerPremio segundoPremio tercerPremio |
	
	self repartirAAgencias.
	
	primerPremio := self calculaJugadasConAciertos: (self mejorSituacion) paraJugada: jugadaGanadora.
	segundoPremio := self calculaJugadasConAciertos: (self mejorSituacion - 1) paraJugada: jugadaGanadora.
	tercerPremio := self calculaJugadasConAciertos: (self mejorSituacion - 2) paraJugada: jugadaGanadora.
	
	self pagarA: primerPremio  conAciertos: (self mejorSituacion).
	self pagarA: segundoPremio  conAciertos: (self mejorSituacion - 1).
	self pagarA: tercerPremio  conAciertos: (self mejorSituacion - 2).
! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:59'!
mejorSituacion 
	self requirement! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 04:26'!
pagarA: apuestasGanadoras conAciertos: numeroDeAciertos
	apuestasGanadoras
		do: [ :apuesta | 
			apuesta agencia
				ganaste: (self pozo * (self porcentajePara: numeroDeAciertos) / apuestasGanadoras size) * self PorcentajeParaAgenciaGanadora]! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:49'!
porcentajePara: numeroAciertos
	self requirement! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 04:16'!
pozo
	^ (self apuestasEnJuego size * self valorDeJugada)
	 ! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:32'!
valorDeJugada 
	self requirement! !

Trait named: #SinPosicion
	uses: {}
	category: 'Tp-TADP'!

!SinPosicion methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:23'!
calculaJugadasConAciertos: numeroDeAciertos paraJugada: jugadaGanadora
	^ self apuestasEnJuego select: [ :unaApuesta | (self cuantosAciertosTiene: (unaApuesta jugada) en: jugadaGanadora) = numeroDeAciertos ]! !

!SinPosicion methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:18'!
cuantosAciertosTiene: unaJugada en: jugadaGanadora
	^ unaJugada inject: 0 into: [ :acum :unNumero | acum + (self siEstaEn: jugadaGanadora sumaUno: unNumero) ]! !

!SinPosicion methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:25'!
siEstaEn: jugadaGanadora sumaUno: unNumero
	(jugadaGanadora includes: unNumero)
		ifTrue: [ ^ 1 ]
		ifFalse: [ ^ 0 ]! !

TestCase subclass: #TestsGenerales
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Test'!

TestCase subclass: #TestsLoto
	instanceVariableNames: 'apuestaLoto agenciaTota juegoLoto jugada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Test'!

!TestsLoto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 04:23'!
testAgenciaGanaFijoPorJugada

	agenciaTota := Agencia new.
	juegoLoto := Loto new.
	jugada := OrderedCollection new.

	jugada addAll: #(1 2).

	juegoLoto apuesto: jugada en: agenciaTota conMonto: 2.
	juegoLoto sorteame: #(5 6 7 8).
	
	self assert: agenciaTota caja equals: (2 * 0.12).! !

!TestsLoto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 04:26'!
testParaVerSiGana

	agenciaTota := Agencia new.
	juegoLoto := Loto new.
	jugada := OrderedCollection new.
	
	jugada addAll: #(4 8 15 16 23 42).

	juegoLoto apuesto: jugada en: agenciaTota conMonto: 2.
	
	juegoLoto sorteame: jugada.
	
	self assert: agenciaTota caja equals: 0.28.! !

!TestsLoto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:22'!
testParaVerSiMeteLaApuesta

	agenciaTota := Agencia new.
	juegoLoto := Loto new.
	jugada := OrderedCollection new.

	jugada addAll: #(1 2).

	juegoLoto apuesto: jugada en: agenciaTota conMonto: 2.
	
	self assert: (juegoLoto apuestasEnJuego size > 0).
	! !

!TestsLoto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:38'!
testPruebaPozo

	agenciaTota := Agencia new.
	juegoLoto := Loto new.
	jugada := OrderedCollection new.

	jugada addAll: #(1 2).

	juegoLoto apuesto: jugada en: agenciaTota conMonto: 2.
	
	juegoLoto sorteame: #(8).
	
	self assert: (agenciaTota caja) equals:  2 * 0.12.! !

TestCase subclass: #TestsPagaOPaga
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Test'!

TestCase subclass: #TestsProde
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Test'!

TestCase subclass: #TestsQuini
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Test'!

Object subclass: #Agencia
	instanceVariableNames: 'caja'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP'!

!Agencia methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:23'!
caja
	^ caja! !

!Agencia methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:33'!
caja: anObject
	caja := anObject! !

!Agencia methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:34'!
ganaste: plata 
	self caja: caja + plata.! !

!Agencia methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:42'!
initialize
	self caja: 0! !

Object subclass: #Apuesta
	instanceVariableNames: 'jugada agencia monto'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP'!

!Apuesta methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:37'!
agencia
	^ agencia.! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:37'!
agencia: unaAgencia
	agencia := unaAgencia.! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:37'!
jugada 
	^jugada! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:34'!
jugada: unaJugada 
	jugada := unaJugada.! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:41'!
monto 
	^ monto! !

!Apuesta methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:41'!
monto: unMonto
	monto := unMonto! !

Object subclass: #Juego
	instanceVariableNames: 'apuestasEnJuego'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP'!

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:42'!
apuestasEnJuego
	^ apuestasEnJuego.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:30'!
apuesto: unaJugada en: unaAgencia conMonto: unNumero
	self subclassResponsibility! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:40'!
calculaGanadoresYRepartiPremios: unaJugada.
	self subclassResponsibility ! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:43'!
initialize 			
	apuestasEnJuego := OrderedCollection new.
		
		! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:40'!
repartirAAgencias
	apuestasEnJuego do: [ :unaApuesta | unaApuesta agencia ganaste: (unaApuesta monto * self PorcentajeFijoPorJugada) ]! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:51'!
sorteame: unaJugada
	self calculaGanadoresYRepartiPremios: unaJugada.! !

Juego subclass: #Loto
	uses: Poceado + SinPosicion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP'!

Loto class
	uses: Poceado classTrait + SinPosicion classTrait
	instanceVariableNames: ''!

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:37'!
PorcentajeFijoPorJugada
	^ 0.12! !

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 04:09'!
PorcentajeParaAgenciaGanadora
	^ 0.05! !

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:03'!
apuesto: unaJugada en: unaAgencia conMonto: unNumero
	| unaApuesta |
	unaApuesta := Apuesta new.
	unaApuesta jugada: unaJugada.
	unaApuesta agencia: unaAgencia.
	unaApuesta monto: unNumero.
	
	self apuestasEnJuego add: unaApuesta.! !

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:43'!
initialize 
	super initialize.! !

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:43'!
mejorSituacion 
	^ 6! !

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:49'!
porcentajePara: unNumero
	unNumero == 6 ifTrue: [^0.4].
	unNumero == 5 ifTrue: [^0.17].
	unNumero == 4 ifTrue: [^0.05].! !

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:57'!
valorDeJugada 
	^ 2.! !

Juego subclass: #PagaOPaga
	uses: SinPosicion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP'!

PagaOPaga class
	uses: SinPosicion classTrait
	instanceVariableNames: ''!

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:44'!
initialize 
	super initialize.! !

Juego subclass: #Prode
	uses: Poceado + ConPosicion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP'!

Prode class
	uses: Poceado classTrait + ConPosicion classTrait
	instanceVariableNames: ''!

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 04:33'!
PorcentajeParaAgenciaGanadora
	^ 0.12! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:44'!
initialize 
	super initialize.! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:50'!
mejorSituacion 
	^ 13! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:50'!
porcentajePara: unNumero
	unNumero == 13 ifTrue: [^0.5].
	unNumero == 12 ifTrue: [^0.35].
	unNumero == 11 ifTrue: [^0.11].! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:51'!
valorDeJugada 
	^ 5! !

Juego subclass: #Quiniela
	uses: ConPosicion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP'!

Quiniela class
	uses: ConPosicion classTrait
	instanceVariableNames: ''!

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:44'!
initialize 
	super initialize.! !
